.\" generated with Ronn/v0.7.3
.\" http://github.com/rtomayko/ronn/tree/0.7.3
.
.TH "ARDUINO\-BUILDER" "1" "March 2018" "Arduino AG" "General Commands Manual"
.
.SH "NAME"
\fBarduino\-builder\fR \- compiles Arduino sketches
.
.SH "SYNOPSIS"
\fBarduino\-builder\fR \fImandatory\-arguments\fR [\fIoptions\fR] \fIsketch\fR
.
.SH "DESCRIPTION"
A command line tool for compiling Arduino sketches
.
.P
This tool is able to parse Arduino Hardware specifications, properly run gcc and produce compiled sketches\.
.
.P
An Arduino sketch differs from a standard C program in that it misses a main (provided by the Arduino core), function prototypes are not mandatory, and libraries inclusion is automagic (you just have to #include them)\. This tool generates function prototypes and gathers library paths, providing gcc with all the needed \-I params\.
.
.SH "OPTIONS"
Every time you run this tool, it will create a 'build\.options\.json' file in build path\. It's used to understand if build options (such as hardware folders, fqbn and so on) were changed when compiling the same sketch\. If they changed, the whole build path is wiped out\. If they didn't change, previous compiled files will be reused if the corresponding source files didn't change as well\. You can save this file locally and use it instead of specifying \fB\-hardware\fR, \fB\-tools\fR, \fB\-libraries\fR, \fB\-fqbn\fR, \fB\-pref\fR and \fB\-ide\-version\fR\.
.
.SS "Mandatory"
.
.TP
\fB\-hardware\fR \fIfolder\fR
\fIfolder\fR containing Arduino platforms\. An example is the 'hardware' folder shipped with the Arduino IDE, or the packages folder created by Arduino Boards Manager\. Can be specified multiple times\. If conflicting hardware definitions are specified, the last one wins\.
.
.TP
\fB\-tools\fR \fIfolder\fR
\fIfolder\fR containing Arduino tools (gcc, avrdude\.\.\.)\. An example is the 'hardware/tools' folder shipped with the Arduino IDE, or the packages folder created by Arduino Boards Manager\. Can be specified multiple times\.
.
.TP
\fB\-fqbn\fR \fIname\fR
Fully Qualified Board Name, e\.g\.: arduino:avr:uno\.
.
.SS "Optional"
.
.TP
\fB\-compile\fR | \fB\-dump\-prefs\fR | \fB\-preprocess\fR
If omitted, defaults to \fB\-compile\fR\. \fBdump\-prefs\fR will just print all build preferences used, \fB\-compile\fR will use those preferences to run the actual compiler, \fB\-preprocess\fR will only print preprocessed code to stdout\.
.
.TP
\fB\-libraries\fR \fIfolder\fR
\fIfolder\fR containing Arduino libraries\. An example is the 'libraries' folder shipped with the Arduino IDE\. Can be specified multiple times\.
.
.TP
\fB\-build\-path\fR \fIfolder\fR
\fIfolder\fR where to save compiled files\. If omitted, a folder will be created in the temporary folder specified by your OS\.
.
.TP
\fB\-prefs\fR=\fIkey\fR=\fIvalue\fR
It allows you to override some build properties\.
.
.TP
\fB\-warnings\fR
Can be "none", "default", "more" and "all"\. Defaults to "none"\. Used to tell gcc which warning level to use (\-W flag)\.
.
.TP
\fB\-verbose\fR
Turns on verbose mode\.
.
.TP
\fB\-quiet\fR
Suppresses almost every output\.
.
.TP
\fB\-debug\-level\fR
Ddefaults to "5"\. Used for debugging\. Set it to 10 when submitting an issue\.
.
.TP
\fB\-core\-api\-version\fR
Defaults to "10600"\. The version of the Arduino IDE which is using this tool\.
.
.TP
\fB\-logger\fR
Can be "human", "humantags" or "machine"\. Defaults to "human"\. If "humantags" the messages are qualified with a prefix that indicates their level (info, debug, error)\. If "machine", messages emitted will be in a format which the Arduino IDE understands and that it uses for I18N\.
.
.TP
\fB\-version\fR
If specified, prints version and exits\.
.
.TP
\fB\-build\-options\-file\fR \fIpath\fR
\fIpath\fR to a local build\.options\.json file, which allows you to omit specifying params such as \fB\-hardware\fR, \fB\-tools\fR, \fB\-libraries\fR, \fB\-fqbn\fR, \fB\-pref\fR and \fB\-ide\-version\fR\.
.
.TP
\fB\-vid\-pid\fR
When specified, VID/PID specific build properties are used, if boards supports them\.
.
.SH "SEE ALSO"
\fBarduino\fR(1)
